#!/bin/bash

set -xe

clang -DSTATIC_SOURCE -g -Weverything -O0 -o xhartae xhartae.c

gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_0.o chapter/chapter_0.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_1.o chapter/chapter_1.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_2.o chapter/chapter_2.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_3.o chapter/chapter_3.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_4.o chapter/chapter_4.c
gcc -g -Wall -Wextra -Wpedantic -O0 -c -o chapter/chapter_5.o chapter/chapter_5.c

gcc -g -Wall -Wextra -Wpedantic -O0 -c -o xhartae.o xhartae.c

gcc -o xhartae xhartae.o chapter/chapter_0.o chapter/chapter_1.o chapter/chapter_2.o chapter/chapter_3.o chapter/chapter_4.o chapter/chapter_5.o

#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_0.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_0.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_1.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_1.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_2.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_2.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_3.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_3.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_4.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_4.c
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_5.h
#~splint -weak -warnposix -retvalother -syntax -type chapter/chapter_5.c
#~splint -weak -warnposix -retvalother -syntax -type xhartae.c

#~valgrind --show-leak-kinds=all --leak-check=full ./xhartae

exit
